
#include <stdio.h>
#include <math.h>

#define PI 3.14159265359

int input(FILE *file);
void setrect(int num, int L, int T, int R, int B, int t);
int FindWay(int x, int y, int time);


int W, H, t, n;
int city[102][102][102];  /* [W][H][t] */
int wayx[102], wayy[102]; /* [t] */
int position[102][102];

int main(void)
{
  FILE *file;
  int robbery=1;
  int x, y, i;
  int numsolutions=0;

  file=fopen("robbery.in", "r");

  while(input(file)){

    numsolutions=0;
     
    printf("\nRobbery #%d\n", robbery);




    /* 1. timestep */
    for(x=1; x<=H; x++){
      for(y=1; y<=W; y++){
	if(city[x][y][1]==1){
          position[x][y]=FindWay(x, y, 1);}
	  else position[x][y]=0;
	if(position[x][y]>0){
	  numsolutions++;   /* count number of solutions for timestep 1 */
	  wayx[numsolutions]=x;
	  wayy[numsolutions]=y;
	}
      }
    }
    



    if(numsolutions>1)printf("Nothing known.\n");
    if(numsolutions==0)printf("The robber has escaped.\n\n");

    /* solution exists */
    else{
      if(numsolutions==1)printf("Time step 1: The robber has been at %d,%d.\n", wayy[1], wayx[1]);
      
      for(i=2; i<=t; i++){
        numsolutions=0;
	x=wayx[1];   y=wayy[1];

        if(city[x+1][y][i]==1 && x+1<=H && FindWay(x+1, y, i))
	  {numsolutions++; wayx[numsolutions]=x+1; wayy[numsolutions]=y;}
        if(city[x][y+1][i]==1 && y+1<=W && FindWay(x, y+1, i))
	  {numsolutions++; wayx[numsolutions]=x; wayy[numsolutions]=y+1;}
        if(city[x][y][i]==1 && FindWay(x, y, i))
	  {numsolutions++; wayx[numsolutions]=x; wayy[numsolutions]=y;}
        if(city[x-1][y][i]==1 && x-1>=1 && FindWay(x-1, y, i))
	  {numsolutions++; wayx[numsolutions]=x-1; wayy[numsolutions]=y;}
        if(city[x][y-1][i]==1 && y-1>=1 && FindWay(x, y-1, i))
	  {numsolutions++; wayx[numsolutions]=x; wayy[numsolutions]=y-1;}





        if(numsolutions>1)printf("Nothing known.\n");
        if(numsolutions==1)printf("Time step %d: The robber has been at %d,%d.\n", i, wayy[1], wayx[1]);
      }

    }

    robbery++;
  }

  exit(0);  
}


int FindWay(int x, int y, int time){

  int num_ways=0;

  if(time==t)return 1;

  if(city[x+1][y][time+1]==1 && x+1<=H)num_ways+=FindWay(x+1, y, time+1);
  if(city[x][y+1][time+1]==1 && y+1<=W)num_ways+=FindWay(x, y+1, time+1);
  if(city[x][y][time+1]==1)num_ways+=FindWay(x, y, time+1);
  if(city[x-1][y][time+1]==1 && x-1>=1)num_ways+=FindWay(x-1, y, time+1);
  if(city[x][y-1][time+1]==1 && y-1>=1)num_ways+=FindWay(x, y-1, time+1);

  return num_ways;

}



int input(FILE *file)
{
  int i,x,y;
  int ti, Li, Ti, Ri, Bi;

  fscanf(file, "%d%d%d", &W, &H, &t);

  if(W==0 && H==0 && t==0)return 0;

  else{
    for(i=1; i<=t; i++)setrect(1, 1, 1, W, H, i);      /* city auf 1 setzen */

    fscanf(file, "%d", &n);

    for(i=0; i<n; i++){
      fscanf(file, "%d%d%d%d%d", &ti, &Li, &Ti, &Ri, &Bi);
      setrect(0, Li, Ti, Ri, Bi, ti);




    }






  }
  return n;
}


void setrect(int num, int L, int T, int R, int B, int t)
{
  int x, y;

  for(x=L; x<=R; x++){
    for(y=T; y<=B; y++){
      city[y][x][t]=num;
    }
  }
}
